#include <fstream>
#include <math.h>

using namespace std;

bool PerfectNumber(long long &a)
{
	long long k = 0;
	for (long long i = 1; i <= sqrt(a); i++)
	{
		if ((double)i == sqrt(a))
		{
			k += i;
		}
		else if (a % i == 0)
		{
			k += i + a / i;
		}
	}
	return k == a * 2;
}

int main()
{
	ifstream input("sohh.inp");
	ofstream output("sohh.out");

	long long a;
	long long n;
	input >> n;
	for (int i = 0; i < n; i++)
	{
		input >> a;
		if (PerfectNumber(a))
		{
			output << a << ' ';
		}
	}
	input.close();
	output.close();
	return 0;
}